/* eslint react/prefer-stateless-function: 0 */
import React, { Component } from 'react'
import { reducer } from 'redux-form'
import { Provider } from 'react-redux'
import hindawiTheme from 'hindawi-theme'
import { createLogger } from 'redux-logger'
import { ThemeProvider } from 'styled-components'
import { client } from 'pubsweet-component-modal'
import { createStore, combineReducers, applyMiddleware } from 'redux'

import withDragDropContext from './withDragDropContext'

const logger = createLogger()
const store = createStore(
  combineReducers({
    form: reducer,
    modal: client.reducers.modal(),
  }),
  applyMiddleware(logger),
)

class Wrapper extends Component {
  render() {
    return (
      <Provider store={store}>
        <ThemeProvider theme={hindawiTheme}>
          {this.props.children}
        </ThemeProvider>
      </Provider>
    )
  }
}

export default withDragDropContext(Wrapper)
